summaryrefslogtreecommitdiff
path: root/home/xyz
diff options
context:
space:
mode:
authorxyz <gky44px1999@gmail.com>2021-10-17 15:39:52 -0700
committerxyz <gky44px1999@gmail.com>2021-10-17 15:39:52 -0700
commitbb83945623fa6cef6c195c98a7776f45974c006c (patch)
tree69ee346d3f9c7fda5bcbd17ac755625929e733af /home/xyz
parent965e09f7e577dfde49bd23efc5ee7449e58a674a (diff)
move work-tree to /, delete mods files, addd cfgL
Diffstat (limited to 'home/xyz')
-rw-r--r--home/xyz/.Xresources6
-rw-r--r--home/xyz/.bashrc56
-rw-r--r--home/xyz/.config/Mullvad VPN/gui_settings.json1
-rw-r--r--home/xyz/.config/aria2/aria2.conf2
-rw-r--r--home/xyz/.config/dunst/dunstrc468
-rw-r--r--home/xyz/.config/fcitx5/conf/classicui.conf15
-rw-r--r--home/xyz/.config/fontconfig/fonts.conf44
-rw-r--r--home/xyz/.config/htop/htoprc44
-rw-r--r--home/xyz/.config/mimeapps.list9
l---------home/xyz/.config/mpv/scripts/sponsorblock-minimal.lua1
-rw-r--r--home/xyz/.config/myconf/gallery_urls5
-rw-r--r--home/xyz/.config/newsboat/config27
-rw-r--r--home/xyz/.config/newsboat/urls26
-rwxr-xr-xhome/xyz/.config/nsxiv/exec/key-handler64
-rw-r--r--home/xyz/.config/readline/inputrc34
-rw-r--r--home/xyz/.config/sxhkd/sxhkdrc57
-rw-r--r--home/xyz/.config/systemd/user/ssh-agent.service24
-rw-r--r--home/xyz/.config/user-dirs.dirs15
-rw-r--r--home/xyz/.config/zathura/zathurarc2
-rwxr-xr-xhome/xyz/.local/bin/cfg24
-rwxr-xr-xhome/xyz/.local/bin/chmodef5
-rwxr-xr-xhome/xyz/.local/bin/convwall34
-rwxr-xr-xhome/xyz/.local/bin/curlkg42
-rwxr-xr-xhome/xyz/.local/bin/curlncm86
-rwxr-xr-xhome/xyz/.local/bin/curlqb18
-rwxr-xr-xhome/xyz/.local/bin/gita18
-rwxr-xr-xhome/xyz/.local/bin/gitfork8
-rwxr-xr-xhome/xyz/.local/bin/gitpu19
-rwxr-xr-xhome/xyz/.local/bin/mmi27
-rwxr-xr-xhome/xyz/.local/bin/mpva11
-rwxr-xr-xhome/xyz/.local/bin/mpvy41
-rwxr-xr-xhome/xyz/.local/bin/mvtr14
-rwxr-xr-xhome/xyz/.local/bin/o15
-rwxr-xr-xhome/xyz/.local/bin/orgext24
-rwxr-xr-xhome/xyz/.local/bin/reco27
-rwxr-xr-xhome/xyz/.local/bin/sbar90
-rwxr-xr-xhome/xyz/.local/bin/shufwall9
-rwxr-xr-xhome/xyz/.local/bin/time.uuid6
-rwxr-xr-xhome/xyz/.local/bin/topa6
-rwxr-xr-xhome/xyz/.local/bin/upd120
-rw-r--r--home/xyz/.profile66
-rw-r--r--home/xyz/.xinitrc52
42 files changed, 1662 insertions, 0 deletions
diff --git a/home/xyz/.Xresources b/home/xyz/.Xresources
new file mode 100644
index 00000000..8953b89e
--- /dev/null
+++ b/home/xyz/.Xresources
@@ -0,0 +1,6 @@
+! nsxiv, fnune/base16-vim base16-tomorrow-night colorscheme
+Nsxiv.bar.font:monospace:size=11
+Nsxiv.window.foreground:#c5c8c6
+Nsxiv.window.background:#1d1f21
+Nsxiv.bar.foreground:#b4b7b4
+Nsxiv.bar.background:#282a2e
diff --git a/home/xyz/.bashrc b/home/xyz/.bashrc
new file mode 100644
index 00000000..78401eb3
--- /dev/null
+++ b/home/xyz/.bashrc
@@ -0,0 +1,56 @@
+#!/bin/sh
+
+# $- meaning see https://stackoverflow.com/questions/42757236/what-does-mean-in-bash
+# If not running interactively, don't do anything
+#[[ $- != *i* ]] && return
+# https://github.com/westscz/.dotfiles/blob/master/system/bashrc
+case $- in
+ *i*) ;;
+ *) return;;
+esac
+
+. /usr/share/fzf/completion.bash
+. /usr/share/fzf/key-bindings.bash
+
+# default PS1
+#PS1='[\u@\h \W]\$ '
+
+# 0: not bold, 91: bright red
+# \e[m act like \e[0m, means reset so commands after it will not be colored
+# https://en.wikipedia.org/wiki/ANSI_escape_code#3-bit_and_4-bit
+# need \[ and \] around color codes so bash ignore color codes when calculating line wraps
+PS1='\[\e[0;91m\][\u@\h \W]\$ \[\e[0m\]'
+
+# https://github.com/LukeSmithxyz/voidrice/blob/master/.config/shell/aliasrc
+for cmd in iotop nethogs hardcode-fixer ventoy; do
+ alias $cmd="sudo $cmd"
+done
+unset cmd
+
+alias absolutely-proprietary='absolutely-proprietary -f'
+alias alsamixer='alsamixer -V all'
+alias diff='diff --color=auto'
+alias grep='grep --color=auto'
+alias ls='ls --color=auto'
+alias radeontop='radeontop -c'
+alias rm='rm -I'
+alias sdcv='sdcv --color'
+
+# /dev/ttyACM0 can be in config file, or as environmantal variable, see /usr/share/doc/adafruit-ampy/README.md
+alias ap='sudo ampy -p /dev/ttyACM0'
+alias cfgc='cfg -c'
+alias cfgl='cfg -l'
+alias cfgs='cfg -s'
+alias g=git
+alias ll='ls -lAh --color=auto --group-directories-first'
+alias s='sudo ' # https://askubuntu.com/a/22043
+alias se='sudo -E '
+alias spd='speedtest --no-upload; librespeed-cli --no-upload'
+alias sv='sudoedit'
+alias tp='sudo tio /dev/ttyACM0'
+alias v='$EDITOR'
+alias vc='$EDITOR "$XDG_DOCUMENTS_DIR/notes/computer/command-line_notes.md"'
+alias vq='$EDITOR "$XDG_DOCUMENTS_DIR/notes/others/questions_ideas_tips.md"'
+alias wtr='curl v2.wttr.in'
+
+eval "$(zoxide init bash)"
diff --git a/home/xyz/.config/Mullvad VPN/gui_settings.json b/home/xyz/.config/Mullvad VPN/gui_settings.json
new file mode 100644
index 00000000..8867e15e
--- /dev/null
+++ b/home/xyz/.config/Mullvad VPN/gui_settings.json
@@ -0,0 +1 @@
+{"preferredLocale":"system","autoConnect":true,"enableSystemNotifications":true,"monochromaticIcon":false,"startMinimized":false,"unpinnedWindow":true,"browsedForSplitTunnelingApplications":[]} \ No newline at end of file
diff --git a/home/xyz/.config/aria2/aria2.conf b/home/xyz/.config/aria2/aria2.conf
new file mode 100644
index 00000000..44bd9c97
--- /dev/null
+++ b/home/xyz/.config/aria2/aria2.conf
@@ -0,0 +1,2 @@
+# max hardcoded to 16, see https://github.com/aria2/aria2/issues/1039
+max-connection-per-server=16
diff --git a/home/xyz/.config/dunst/dunstrc b/home/xyz/.config/dunst/dunstrc
new file mode 100644
index 00000000..987c65cb
--- /dev/null
+++ b/home/xyz/.config/dunst/dunstrc
@@ -0,0 +1,468 @@
+[global]
+ ### Display ###
+
+ # Which monitor should the notifications be displayed on.
+ monitor = 0
+
+ # Display notification on focused monitor. Possible modes are:
+ # mouse: follow mouse pointer
+ # keyboard: follow window with keyboard focus
+ # none: don't follow anything
+ #
+ # "keyboard" needs a window manager that exports the
+ # _NET_ACTIVE_WINDOW property.
+ # This should be the case for almost all modern window managers.
+ #
+ # If this option is set to mouse or keyboard, the monitor option
+ # will be ignored.
+ follow = mouse
+
+ # The geometry of the window:
+ # [{width}]x{height}[+/-{x}+/-{y}]
+ # The geometry of the message window.
+ # The height is measured in number of notifications everything else
+ # in pixels. If the width is omitted but the height is given
+ # ("-geometry x2"), the message window expands over the whole screen
+ # (dmenu-like). If width is 0, the window expands to the longest
+ # message displayed. A positive x is measured from the left, a
+ # negative from the right side of the screen. Y is measured from
+ # the top and down respectively.
+ # The width can be negative. In this case the actual width is the
+ # screen width minus the width defined in within the geometry option.
+ geometry = "300x5-30+20"
+
+ # Turn on the progess bar
+ progress_bar = true
+
+ # Set the progress bar height. This includes the frame, so make sure
+ # it's at least twice as big as the frame width.
+ progress_bar_height = 10
+
+ # Set the frame width of the progress bar
+ progress_bar_frame_width = 1
+
+ # Set the minimum width for the progress bar
+ progress_bar_min_width = 150
+
+ # Set the maximum width for the progress bar
+ progress_bar_max_width = 300
+
+
+ # Show how many messages are currently hidden (because of geometry).
+ indicate_hidden = yes
+
+ # Shrink window if it's smaller than the width. Will be ignored if
+ # width is 0.
+ shrink = yes
+
+ # The transparency of the window. Range: [0; 100].
+ # This option will only work if a compositing window manager is
+ # present (e.g. xcompmgr, compiz, etc.).
+ transparency = 0
+
+ # The height of the entire notification. If the height is smaller
+ # than the font height and padding combined, it will be raised
+ # to the font height and padding.
+ notification_height = 0
+
+ # Draw a line of "separator_height" pixel height between two
+ # notifications.
+ # Set to 0 to disable.
+ separator_height = 1
+
+ # Padding between text and separator.
+ padding = 8
+
+ # Horizontal padding.
+ horizontal_padding = 8
+
+ # Padding between text and icon.
+ text_icon_padding = 0
+
+ # Defines width in pixels of frame around the notification window.
+ # Set to 0 to disable.
+ frame_width = 1
+
+ # Defines color of the frame around the notification window.
+ frame_color = "#c5c8c6"
+
+ # Define a color for the separator.
+ # possible values are:
+ # * auto: dunst tries to find a color fitting to the background;
+ # * foreground: use the same color as the foreground;
+ # * frame: use the same color as the frame;
+ # * anything else will be interpreted as a X color.
+ separator_color = frame
+
+ # Sort messages by urgency.
+ sort = yes
+
+ # Don't remove messages, if the user is idle (no mouse or keyboard input)
+ # for longer than idle_threshold seconds.
+ # Set to 0 to disable.
+ # A client can set the 'transient' hint to bypass this. See the rules
+ # section for how to disable this if necessary
+ idle_threshold = 120
+
+ ### Text ###
+
+ font = Monospace 10
+
+ # The spacing between lines. If the height is smaller than the
+ # font height, it will get raised to the font height.
+ line_height = 0
+
+ # Possible values are:
+ # full: Allow a small subset of html markup in notifications:
+ # <b>bold</b>
+ # <i>italic</i>
+ # <s>strikethrough</s>
+ # <u>underline</u>
+ #
+ # For a complete reference see
+ # <https://developer.gnome.org/pango/stable/pango-Markup.html>.
+ #
+ # strip: This setting is provided for compatibility with some broken
+ # clients that send markup even though it's not enabled on the
+ # server. Dunst will try to strip the markup but the parsing is
+ # simplistic so using this option outside of matching rules for
+ # specific applications *IS GREATLY DISCOURAGED*.
+ #
+ # no: Disable markup parsing, incoming notifications will be treated as
+ # plain text. Dunst will not advertise that it has the body-markup
+ # capability if this is set as a global setting.
+ #
+ # It's important to note that markup inside the format option will be parsed
+ # regardless of what this is set to.
+ markup = full
+
+ # The format of the message. Possible variables are:
+ # %a appname
+ # %s summary
+ # %b body
+ # %i iconname (including its path)
+ # %I iconname (without its path)
+ # %p progress value if set ([ 0%] to [100%]) or nothing
+ # %n progress value if set without any extra characters
+ # %% Literal %
+ # Markup is allowed
+ format = "<b>%s</b>\n%b"
+
+ # Alignment of message text.
+ # Possible values are "left", "center" and "right".
+ alignment = left
+
+ # Vertical alignment of message text and icon.
+ # Possible values are "top", "center" and "bottom".
+ vertical_alignment = center
+
+ # Show age of message if message is older than show_age_threshold
+ # seconds.
+ # Set to -1 to disable.
+ show_age_threshold = 60
+
+ # Split notifications into multiple lines if they don't fit into
+ # geometry.
+ word_wrap = yes
+
+ # When word_wrap is set to no, specify where to make an ellipsis in long lines.
+ # Possible values are "start", "middle" and "end".
+ ellipsize = middle
+
+ # Ignore newlines '\n' in notifications.
+ ignore_newline = no
+
+ # Stack together notifications with the same content
+ stack_duplicates = true
+
+ # Hide the count of stacked notifications with the same content
+ hide_duplicate_count = false
+
+ # Display indicators for URLs (U) and actions (A).
+ show_indicators = yes
+
+ ### Icons ###
+
+ # Align icons left/right/off
+ icon_position = left
+
+ # Scale small icons up to this size, set to 0 to disable. Helpful
+ # for e.g. small files or high-dpi screens. In case of conflict,
+ # max_icon_size takes precedence over this.
+ min_icon_size = 0
+
+ # Scale larger icons down to this size, set to 0 to disable
+ max_icon_size = 32
+
+ # Paths to default icons.
+ icon_path = /usr/share/icons/Papirus-Dark/16x16/actions:/usr/share/icons/Papirus-Dark/16x16/categories:/usr/share/icons/Papirus-Dark/16x16/emblems:/usr/share/icons/Papirus-Dark/16x16/mimetypes:/usr/share/icons/Papirus-Dark/16x16/places:/usr/share/icons/Papirus-Dark/16x16/apps:/usr/share/icons/Papirus-Dark/16x16/devices:/usr/share/icons/Papirus-Dark/16x16/emotes:/usr/share/icons/Papirus-Dark/16x16/panel:/usr/share/icons/Papirus-Dark/16x16/status
+
+ ### History ###
+
+ # Should a notification popped up from history be sticky or timeout
+ # as if it would normally do.
+ sticky_history = yes
+
+ # Maximum amount of notifications kept in history
+ history_length = 20
+
+ ### Misc/Advanced ###
+
+ # dmenu path.
+ dmenu = /usr/bin/dmenu -p dunst:
+
+ # Browser for opening urls in context menu.
+ browser = /usr/bin/firefox -new-tab
+
+ # Always run rule-defined scripts, even if the notification is suppressed
+ always_run_script = true
+
+ # Define the title of the windows spawned by dunst
+ title = Dunst
+
+ # Define the class of the windows spawned by dunst
+ class = Dunst
+
+ # Print a notification on startup.
+ # This is mainly for error detection, since dbus (re-)starts dunst
+ # automatically after a crash.
+ startup_notification = false
+
+ # Manage dunst's desire for talking
+ # Can be one of the following values:
+ # crit: Critical features. Dunst aborts
+ # warn: Only non-fatal warnings
+ # mesg: Important Messages
+ # info: all unimportant stuff
+ # debug: all less than unimportant stuff
+ verbosity = mesg
+
+ # Define the corner radius of the notification window
+ # in pixel size. If the radius is 0, you have no rounded
+ # corners.
+ # The radius will be automatically lowered if it exceeds half of the
+ # notification height to avoid clipping text and/or icons.
+ corner_radius = 0
+
+ # Ignore the dbus closeNotification message.
+ # Useful to enforce the timeout set by dunst configuration. Without this
+ # parameter, an application may close the notification sent before the
+ # user defined timeout.
+ ignore_dbusclose = false
+
+ ### Wayland ###
+ # These settings are Wayland-specific. They have no effect when using X11
+
+ # Uncomment this if you want to let notications appear under fullscreen
+ # applications (default: overlay)
+ # layer = top
+
+ # Set this to true to use X11 output on Wayland.
+ force_xwayland = false
+
+ ### Legacy
+
+ # Use the Xinerama extension instead of RandR for multi-monitor support.
+ # This setting is provided for compatibility with older nVidia drivers that
+ # do not support RandR and using it on systems that support RandR is highly
+ # discouraged.
+ #
+ # By enabling this setting dunst will not be able to detect when a monitor
+ # is connected or disconnected which might break follow mode if the screen
+ # layout changes.
+ force_xinerama = false
+
+ ### mouse
+
+ # Defines list of actions for each mouse event
+ # Possible values are:
+ # * none: Don't do anything.
+ # * do_action: If the notification has exactly one action, or one is marked as default,
+ # invoke it. If there are multiple and no default, open the context menu.
+ # * close_current: Close current notification.
+ # * close_all: Close all notifications.
+ # These values can be strung together for each mouse event, and
+ # will be executed in sequence.
+ mouse_left_click = close_current
+ mouse_middle_click = do_action, close_current
+ mouse_right_click = close_all
+
+# Experimental features that may or may not work correctly. Do not expect them
+# to have a consistent behaviour across releases.
+[experimental]
+ # Calculate the dpi to use on a per-monitor basis.
+ # If this setting is enabled the Xft.dpi value will be ignored and instead
+ # dunst will attempt to calculate an appropriate dpi value for each monitor
+ # using the resolution and physical size. This might be useful in setups
+ # where there are multiple screens with very different dpi values.
+ per_monitor_dpi = false
+
+# The internal keyboard shortcut support in dunst is now considered deprecated
+# and should be replaced by dunstctl calls. You can use the configuration of your
+# WM or DE to bind these to shortcuts of your choice.
+# Check the dunstctl manual page for more info.
+[shortcuts]
+
+ # Shortcuts are specified as [modifier+][modifier+]...key
+ # Available modifiers are "ctrl", "mod1" (the alt-key), "mod2",
+ # "mod3" and "mod4" (windows-key).
+ # Xev might be helpful to find names for keys.
+
+ # Close notification. Equivalent dunstctl command:
+ # dunstctl close
+ # close = ctrl+space
+
+ # Close all notifications. Equivalent dunstctl command:
+ # dunstctl close-all
+ # close_all = ctrl+shift+space
+
+ # Redisplay last message(s). Equivalent dunstctl command:
+ # dunstctl history-pop
+ # history = ctrl+grave
+
+ # Context menu. Equivalent dunstctl command:
+ # dunstctl context
+ # context = ctrl+shift+period
+
+[urgency_low]
+ # IMPORTANT: colors have to be defined in quotation marks.
+ # Otherwise the "#" and following would be interpreted as a comment.
+ background = "#1d1f21"
+ foreground = "#81a2be"
+ frame_color = "#81a2be"
+ timeout = 10
+ # Icon for notifications with low urgency, uncomment to enable
+ #icon = /path/to/icon
+
+[urgency_normal]
+ background = "#1d1f21"
+ foreground = "#b5bd68"
+ frame_color = "#b5bd68"
+ timeout = 10
+ # Icon for notifications with normal urgency, uncomment to enable
+ #icon = /path/to/icon
+
+[urgency_critical]
+ background = "#1d1f21"
+ foreground = "#cc6666"
+ frame_color = "#cc6666"
+ timeout = 0
+ # Icon for notifications with critical urgency, uncomment to enable
+ #icon = /path/to/icon
+
+# Every section that isn't one of the above is interpreted as a rules to
+# override settings for certain messages.
+#
+# Messages can be matched by
+# appname (discouraged, see desktop_entry)
+# body
+# category
+# desktop_entry
+# icon
+# match_transient
+# msg_urgency
+# stack_tag
+# summary
+#
+# and you can override the
+# background
+# foreground
+# format
+# frame_color
+# fullscreen
+# new_icon
+# set_stack_tag
+# set_transient
+# timeout
+# urgency
+#
+# Shell-like globbing will get expanded.
+#
+# Instead of the appname filter, it's recommended to use the desktop_entry filter.
+# GLib based applications export their desktop-entry name. In comparison to the appname,
+# the desktop-entry won't get localized.
+#
+# SCRIPTING
+# You can specify a script that gets run when the rule matches by
+# setting the "script" option.
+# The script will be called as follows:
+# script appname summary body icon urgency
+# where urgency can be "LOW", "NORMAL" or "CRITICAL".
+#
+# NOTE: if you don't want a notification to be displayed, set the format
+# to "".
+# NOTE: It might be helpful to run dunst -print in a terminal in order
+# to find fitting options for rules.
+
+# Disable the transient hint so that idle_threshold cannot be bypassed from the
+# client
+#[transient_disable]
+# match_transient = yes
+# set_transient = no
+#
+# Make the handling of transient notifications more strict by making them not
+# be placed in history.
+#[transient_history_ignore]
+# match_transient = yes
+# history_ignore = yes
+
+# fullscreen values
+# show: show the notifications, regardless if there is a fullscreen window opened
+# delay: displays the new notification, if there is no fullscreen window active
+# If the notification is already drawn, it won't get undrawn.
+# pushback: same as delay, but when switching into fullscreen, the notification will get
+# withdrawn from screen again and will get delayed like a new notification
+#[fullscreen_delay_everything]
+# fullscreen = delay
+#[fullscreen_show_critical]
+# msg_urgency = critical
+# fullscreen = show
+
+#[espeak]
+# summary = "*"
+# script = dunst_espeak.sh
+
+#[script-test]
+# summary = "*script*"
+# script = dunst_test.sh
+
+#[ignore]
+# # This notification will not be displayed
+# summary = "foobar"
+# format = ""
+
+#[history-ignore]
+# # This notification will not be saved in history
+# summary = "foobar"
+# history_ignore = yes
+
+#[skip-display]
+# # This notification will not be displayed, but will be included in the history
+# summary = "foobar"
+# skip_display = yes
+
+#[signed_on]
+# appname = Pidgin
+# summary = "*signed on*"
+# urgency = low
+#
+#[signed_off]
+# appname = Pidgin
+# summary = *signed off*
+# urgency = low
+#
+#[says]
+# appname = Pidgin
+# summary = *says*
+# urgency = critical
+#
+#[twitter]
+# appname = Pidgin
+# summary = *twitter.com*
+# urgency = normal
+#
+#[stack-volumes]
+# appname = "some_volume_notifiers"
+# set_stack_tag = "volume"
+#
+# vim: ft=cfg
diff --git a/home/xyz/.config/fcitx5/conf/classicui.conf b/home/xyz/.config/fcitx5/conf/classicui.conf
new file mode 100644
index 00000000..6986df92
--- /dev/null
+++ b/home/xyz/.config/fcitx5/conf/classicui.conf
@@ -0,0 +1,15 @@
+# Vertical Candidate List
+Vertical Candidate List=False
+# Use Per Screen DPI
+PerScreenDPI=True
+# Use mouse wheel to go to prev or next page
+WheelForPaging=True
+# Font
+Font="Adobe Kaiti Std 12"
+# Menu Font
+MenuFont="Sans 10"
+# Use input method langauge to display text
+UseInputMethodLangaugeToDisplayText=True
+# Theme
+Theme=default
+
diff --git a/home/xyz/.config/fontconfig/fonts.conf b/home/xyz/.config/fontconfig/fonts.conf
new file mode 100644
index 00000000..c8b6287f
--- /dev/null
+++ b/home/xyz/.config/fontconfig/fonts.conf
@@ -0,0 +1,44 @@
+<?xml version="1.0"?>
+<!DOCTYPE fontconfig SYSTEM "urn:fontconfig:fonts.dtd">
+<fontconfig>
+
+ <!-- more details: http://www.jinbuguo.com/gui/linux_fontconfig.html -->
+
+ <alias>
+ <family>serif</family>
+ <prefer>
+ <family>Noto Serif</family>
+ <family>Noto Serif CJK SC</family>
+ <family>Noto Color Emoji</family>
+ </prefer>
+ </alias>
+ <alias>
+ <family>sans-serif</family>
+ <prefer>
+ <family>Noto Sans</family>
+ <family>Noto Sans CJK SC</family>
+ <family>Noto Color Emoji</family>
+ </prefer>
+ </alias>
+ <alias>
+ <family>monospace</family>
+ <prefer>
+ <family>Noto Sans Mono</family>
+ <family>Noto Sans Mono CJK SC</family>
+ <family>Noto Color Emoji</family>
+ </prefer>
+ </alias>
+
+ <!-- man fonts-conf example approach -->
+ <!--
+ <match>
+ <test name="lang" compare="contains">
+ <string>zh</string>
+ </test>
+ <edit name="family" mode="prepend">
+ <string>Adobe Kaiti Std</string>
+ </edit>
+ </match>
+ -->
+
+</fontconfig>
diff --git a/home/xyz/.config/htop/htoprc b/home/xyz/.config/htop/htoprc
new file mode 100644
index 00000000..48d07e69
--- /dev/null
+++ b/home/xyz/.config/htop/htoprc
@@ -0,0 +1,44 @@
+# Beware! This file is rewritten by htop when settings are changed in the interface.
+# The parser is also very primitive, and not human-friendly.
+htop_version=3.1.0
+config_reader_min_version=2
+fields=0 48 17 18 38 39 40 2 46 47 49 1
+sort_key=46
+sort_direction=-1
+tree_sort_key=0
+tree_sort_direction=1
+hide_kernel_threads=1
+hide_userland_threads=1
+shadow_other_users=0
+show_thread_names=0
+show_program_path=1
+highlight_base_name=0
+highlight_deleted_exe=1
+highlight_megabytes=1
+highlight_threads=1
+highlight_changes=0
+highlight_changes_delay_secs=5
+find_comm_in_cmdline=1
+strip_exe_from_cmdline=1
+show_merged_command=0
+tree_view=0
+tree_view_always_by_pid=0
+all_branches_collapsed=0
+header_margin=1
+detailed_cpu_time=0
+cpu_count_from_one=0
+show_cpu_usage=1
+show_cpu_frequency=1
+show_cpu_temperature=1
+degree_fahrenheit=0
+update_process_names=0
+account_guest_in_cpu_meter=0
+color_scheme=0
+enable_mouse=1
+delay=15
+hide_function_bar=0
+header_layout=two_50_50
+column_meters_0=AllCPUs Memory Swap
+column_meter_modes_0=1 1 1
+column_meters_1=Tasks LoadAverage DiskIO NetworkIO
+column_meter_modes_1=2 2 2 2
diff --git a/home/xyz/.config/mimeapps.list b/home/xyz/.config/mimeapps.list
new file mode 100644
index 00000000..9a21f46e
--- /dev/null
+++ b/home/xyz/.config/mimeapps.list
@@ -0,0 +1,9 @@
+# it seems there's no need to put sxiv.desktop into ~/.local/share/applications/ if there exist sxiv.desktop in /usr/share/applications
+# no need to use xdg-mime to install it if already exist?
+# but if you what to create new .desktop desktop entries with new name, you need to put it in ~/.local/share/applications/
+
+[Default Applications]
+image/gif=nsxiv.desktop;
+image/png=nsxiv.desktop;
+image/jpeg=nsxiv.desktop;
+application/pdf=org.pwmt.zathura.desktop;
diff --git a/home/xyz/.config/mpv/scripts/sponsorblock-minimal.lua b/home/xyz/.config/mpv/scripts/sponsorblock-minimal.lua
new file mode 120000
index 00000000..cb3390f8
--- /dev/null
+++ b/home/xyz/.config/mpv/scripts/sponsorblock-minimal.lua
@@ -0,0 +1 @@
+/usr/lib/mpv/sponsorblock-minimal.lua \ No newline at end of file
diff --git a/home/xyz/.config/myconf/gallery_urls b/home/xyz/.config/myconf/gallery_urls
new file mode 100644
index 00000000..c0ffd026
--- /dev/null
+++ b/home/xyz/.config/myconf/gallery_urls
@@ -0,0 +1,5 @@
+# input file format see https://github.com/mikf/gallery-dl/blob/13d4045a8a5a6fd45cb20df399f44055b25f5cca/gallery_dl/__init__.py#L33-L58
+https://www.pixiv.net/users/13379747/artworks
+https://www.deviantart.com/wlop/gallery
+https://www.deviantart.com/minimalistic-animoo/gallery/
+https://www.deviantart.com/theminimalists/gallery/
diff --git a/home/xyz/.config/newsboat/config b/home/xyz/.config/newsboat/config
new file mode 100644
index 00000000..8b31ecb8
--- /dev/null
+++ b/home/xyz/.config/newsboat/config
@@ -0,0 +1,27 @@
+auto-reload yes
+
+bind-key h quit
+bind-key j down
+bind-key k up
+bind-key l open
+bind-key g home
+bind-key G end
+bind-key ^F pagedown
+bind-key ^B pageup
+
+# open-in-browser-noninteractively may be useful
+macro y set browser "echo %u | xsel -ib"; open-in-browser; set browser "$BROWSER %u &"
+
+# https://newsboat.org/releases/2.24/docs/newsboat.html#_killfiles
+# https://newsboat.org/releases/2.24/docs/newsboat.html#_filter_language
+
+# not sure if all following arch linux rss feed ignore-article will work as expected
+# maybe aur rss feed is broken; maybe arch linux feeds are updated very fast so I can't get the wanted news?
+# not fully understand the rss feed
+ignore-article "https://aur.archlinux.org/rss/" "title !~\"youtube-dlp|yt-dlp\""
+# arch linux development feeds: all project
+ignore-article "https://bugs.archlinux.org/feed.php?feed_type=rss2&project=0" "title !~ \"wildmidi|aur.*(rss|feed)|(rss|feed).*aur\""
+ignore-article "https://bugs.archlinux.org/feed.php?feed_type=rss2&topic=edit&project=0" "title !~ \"FS#(47508|71501|71453|70113|69492)|wildmidi|aur.*(rss|feed)|(rss|feed).*aur\""
+ignore-article "https://bugs.archlinux.org/feed.php?feed_type=rss2&topic=clo&project=0" "title !~ \"FS#(47508|71501|71453|70113|69492)|wildmidi|aur.*(rss|feed)|(rss|feed).*aur\""
+
+# vim: ft=sh
diff --git a/home/xyz/.config/newsboat/urls b/home/xyz/.config/newsboat/urls
new file mode 100644
index 00000000..100fcb00
--- /dev/null
+++ b/home/xyz/.config/newsboat/urls
@@ -0,0 +1,26 @@
+# https://newsboat.org/releases/2.24/docs/newsboat.html#_tagging
+
+# temp
+https://github.community/t/why-forked-repos-are-not-automatically-watched/205774.rss
+
+# recreation
+https://www.youtube.com/feeds/videos.xml?channel_id=UCD6VugMZKRhSyzWEWA9W2fg recreation
+http://keygenmusic.net/rss.php recreation
+
+# computer misc
+https://suckless.org/atom.xml
+https://ryf.fsf.org/news/rss.xml
+https://ryf.fsf.org/products/rss.xml
+
+# arch linux
+https://archlinux.org/feeds/news/
+https://bbs.archlinux.org/extern.php?action=feed&tid=260286&type=atom
+https://aur.archlinux.org/rss/
+# arch linux development feeds: all projects
+https://bugs.archlinux.org/feed.php?feed_type=rss2&project=0
+https://bugs.archlinux.org/feed.php?feed_type=rss2&topic=edit&project=0
+https://bugs.archlinux.org/feed.php?feed_type=rss2&topic=clo&project=0
+
+# qmmp
+https://sourceforge.net/p/qmmp-dev/tickets/590/feed.atom
+https://sourceforge.net/p/qmmp-dev/tickets/714/feed.atom
diff --git a/home/xyz/.config/nsxiv/exec/key-handler b/home/xyz/.config/nsxiv/exec/key-handler
new file mode 100755
index 00000000..80dd82f0
--- /dev/null
+++ b/home/xyz/.config/nsxiv/exec/key-handler
@@ -0,0 +1,64 @@
+#!/bin/sh
+
+# Example for $XDG_CONFIG_HOME/sxiv/exec/key-handler
+# Called by sxiv(1) after the external prefix key (C-x by default) is pressed.
+# The next key combo is passed as its first argument. Passed via stdin are the
+# images to act upon, one path per line: all marked images, if in thumbnail
+# mode and at least one image has been marked, otherwise the current image.
+# sxiv(1) blocks until this script terminates. It then checks which images
+# have been modified and reloads them.
+
+# The key combo argument has the following form: "[C-][M-][S-]KEY",
+# where C/M/S indicate Ctrl/Meta(Alt)/Shift modifier states and KEY is the X
+# keysym as listed in /usr/include/X11/keysymdef.h without the "XK_" prefix.
+
+# my dependency notes
+# jpegtran is owned by libjpeg-turbo
+# mogrify is owned by imagemagick
+# exiv2 is owned by exiv2
+# rawtherapee is owned by rawtherapee
+
+rotate() {
+ tr '\n' '\0' | xargs -0 realpath | sort | uniq | while read -r file; do
+ case "$(file -b -i "$file")" in
+ image/jpeg*) jpegtran -rotate 90 -copy all -outfile "$file" "$file" ;;
+ *) mogrify -rotate 90 "$file" ;;
+ esac
+ done
+}
+
+flip() {
+ tr '\n' '\0' | xargs -0 realpath | sort | uniq | while read -r file; do
+ case "$(file -b -i "$file")" in
+ image/jpeg*) jpegtran -flip vertical -copy all -outfile "$file" "$file" ;;
+ *) mogrify -flip "$file" ;;
+ esac
+ done
+}
+
+linkwall() {
+ tr '\n' '\0' | xargs -0 realpath | sort | uniq | while read -r file; do
+ walldir="$XDG_PICTURES_DIR/wallpapers/"
+ name=$(basename "$file")
+ if [ ! -e "$walldir$name" ]; then
+ convwall "$file" "$walldir$name" || ln -s "$file" "$walldir"
+ else
+ notify-send 'error' "$name exist"
+ fi
+ done
+}
+
+# I choose not to put case nested in while read file loop
+# because it can pipe multiple files to one command?
+case "$1" in
+ "d") [ "$(printf 'No\nYes' | dmenu -i -p 'delete?')" = "Yes" ] && tr '\n' '\0' | xargs -0 rm ;;
+ "e") while read -r file; do alacritty -e sh -c "exiv2 pr -q -pa '$file' | less" & done ;;
+ "f") flip ;;
+ "g") tr '\n' '\0' | xargs -0 setsid -f gimp ;;
+ "l") linkwall ;;
+ "p") tr '\n' '\0' | xargs -0 sh -c 'convert "$@" $(time.uuid).pdf' shell ;;
+ "r") rotate ;;
+ "w") tr '\n' '\0' | xargs -0 shufwall ;;
+ "y") tr '\n' '\0' | xargs -0 realpath | xsel -b ;;
+esac
+
diff --git a/home/xyz/.config/readline/inputrc b/home/xyz/.config/readline/inputrc
new file mode 100644
index 00000000..a666b091
--- /dev/null
+++ b/home/xyz/.config/readline/inputrc
@@ -0,0 +1,34 @@
+$include /etc/inputrc
+
+# from archwiki realine
+# Color files by types
+# Note that this may cause completion text blink in some terminals (e.g. xterm).
+set colored-stats On
+# Append char to indicate type
+set visible-stats On
+# Mark symlinked directories
+set mark-symlinked-directories On
+# Color the common prefix
+set colored-completion-prefix On
+# Color the common prefix in menu-complete
+set menu-complete-display-prefix On
+
+# https://github.com/LukeSmithxyz/voidrice/blob/2440ad83e9e9cf2f927efbaef618513e0df3cbda/.config/shell/inputrc
+set editing-mode vi
+$if mode=vi
+
+ set show-mode-in-prompt on
+ set vi-ins-mode-string \1\e[6 q\2
+ set vi-cmd-mode-string \1\e[2 q\2
+
+ #set keymap vi-command
+ # these are for vi-command mode
+ #Control-l: clear-screen
+ #Control-a: beginning-of-line
+
+ set keymap vi-insert
+ # these are for vi-insert mode
+ Control-l: clear-screen
+ #Control-a: beginning-of-line
+
+$endif
diff --git a/home/xyz/.config/sxhkd/sxhkdrc b/home/xyz/.config/sxhkd/sxhkdrc
new file mode 100644
index 00000000..f84cf529
--- /dev/null
+++ b/home/xyz/.config/sxhkd/sxhkdrc
@@ -0,0 +1,57 @@
+Print
+ ffmpeg -f x11grab -i "$DISPLAY" -vframes 1 "$XDG_PICTURES_DIR/screenshots/$(time.uuid).png"
+
+alt + Print
+ xrectsel '%w %h %x %y' | xargs sh -c 'ffmpeg -f x11grab -s "$1"x"$2" -i "$DISPLAY+$3,$4" -vframes 1 "$XDG_PICTURES_DIR/screenshots/$(time.uuid).png"' shell
+
+alt + shift + Print
+ reco
+
+XF86Audio{RaiseVolume,LowerVolume,Mute}
+ amixer set Master {5%+,5%-,toggle};\
+ kill -RTMIN+1 "$(cat "$XDG_CACHE_HOME/pidofbar")"
+
+# for pulseaudio, master volume affects capture volume too?
+# my laptop built-in microphone capture volume is really low
+# so I want to keep capture volume always 100%
+alt + XF86AudioMute
+ amixer set Capture toggle;\
+ kill -RTMIN "$(cat "$XDG_CACHE_HOME/pidofbar")"
+
+XF86Audio{Prev,Play,Next}
+ playerctl {previous,play-pause,next}
+
+@Caps_Lock
+ kill -RTMIN+3 "$(cat "$XDG_CACHE_HOME/pidofbar")"
+
+alt + y
+ mpvy -s
+
+alt + shift + y
+ mpvy -a
+
+alt + ctrl + y
+ tsp mpvy -A -u "$(xsel -ob)"
+
+alt + w
+ "$BROWSER"
+
+# not ideal
+alt + shift + w
+ mullvad-exclude "$BROWSER"
+
+alt + s
+ shufwall
+
+# not ideal
+alt + v
+ if mullvad status | grep -q 'Disconnect'; then mullvad connect -w; else killall qbittorrent; mullvad disconnect -w; fi;\
+ kill -RTMIN+4 "$(cat "$XDG_CACHE_HOME/pidofbar")"
+
+# not ideal
+alt + q
+ mullvad connect -w;\
+ kill -RTMIN+4 "$(cat "$XDG_CACHE_HOME/pidofbar")";\
+ qbittorrent
+
+# vim: ft=sh
diff --git a/home/xyz/.config/systemd/user/ssh-agent.service b/home/xyz/.config/systemd/user/ssh-agent.service
new file mode 100644
index 00000000..66fa63ef
--- /dev/null
+++ b/home/xyz/.config/systemd/user/ssh-agent.service
@@ -0,0 +1,24 @@
+# how to use:
+# systemctl --user enable --now ssh-agent
+
+[Unit]
+Description=SSH key agent
+
+# archwiki approach
+# https://wiki.archlinux.org/title/SSH_keys#Start_ssh-agent_with_systemd_user
+[Service]
+Type=simple
+Environment=SSH_AUTH_SOCK=%t/ssh-agent.socket
+# DISPLAY required for ssh-askpass to work
+Environment=DISPLAY=:0
+ExecStart=/usr/bin/ssh-agent -D -a $SSH_AUTH_SOCK
+
+# github White-Oak approach
+# https://github.com/White-Oak/arch-setup-for-dummies/blob/master/setting-up-ssh-agent.md
+#[Service]
+#Type=forking
+#Environment=SSH_AUTH_SOCK=%t/ssh-agent.socket
+#ExecStart=/usr/bin/ssh-agent -a $SSH_AUTH_SOCK
+
+[Install]
+WantedBy=default.target
diff --git a/home/xyz/.config/user-dirs.dirs b/home/xyz/.config/user-dirs.dirs
new file mode 100644
index 00000000..85cab233
--- /dev/null
+++ b/home/xyz/.config/user-dirs.dirs
@@ -0,0 +1,15 @@
+# This file is written by xdg-user-dirs-update
+# If you want to change or add directories, just edit the line you're
+# interested in. All local changes will be retained on the next run.
+# Format is XDG_xxx_DIR="$HOME/yyy", where yyy is a shell-escaped
+# homedir-relative path, or XDG_xxx_DIR="/yyy", where /yyy is an
+# absolute path. No other format is supported.
+
+XDG_DESKTOP_DIR="$HOME/desktop/"
+XDG_DOWNLOAD_DIR="$HOME/downloads/"
+XDG_TEMPLATES_DIR="$HOME/"
+XDG_PUBLICSHARE_DIR="$HOME/"
+XDG_DOCUMENTS_DIR="$HOME/documents/"
+XDG_MUSIC_DIR="$HOME/music/"
+XDG_PICTURES_DIR="$HOME/pictures/"
+XDG_VIDEOS_DIR="$HOME/videos/"
diff --git a/home/xyz/.config/zathura/zathurarc b/home/xyz/.config/zathura/zathurarc
new file mode 100644
index 00000000..2c49960e
--- /dev/null
+++ b/home/xyz/.config/zathura/zathurarc
@@ -0,0 +1,2 @@
+# mouse selection copy to clipboard instead of primary
+set selection-clipboard clipboard
diff --git a/home/xyz/.local/bin/cfg b/home/xyz/.local/bin/cfg
new file mode 100755
index 00000000..de40874a
--- /dev/null
+++ b/home/xyz/.local/bin/cfg
@@ -0,0 +1,24 @@
+#!/bin/sh
+
+# didn't consider $HOME contain space? need improve?
+while getopts clLsSmM opt; do
+ case $opt in
+ c|l|s) dir="$HOME"
+ cmd="git --git-dir=$dir/.cfg$opt/ --work-tree=$dir"
+ mods="$XDG_CONFIG_HOME/myconf/cfg${opt}_mods";;
+ L|S) dir=/etc/
+ cmd="sudo git --git-dir=$dir/.cfg$opt/ --work-tree=$dir"
+ mods="/etc/myconf/cfg${opt}_mods";;
+ # -rw-r--r-- == binary 110100100 == octal 644
+ # https://stackoverflow.com/a/1796009
+ m) $cmd ls-tree -r --name-only --full-tree HEAD | nawk -v a="$dir/" '{printf("%s%s\n",a,$0)}' | tr '\n' '\0' | xargs -0 ls -ldA -- | grep -v '^l\|^d' | nawk '{k=0;for(i=0;i<=8;i++)k+=((substr($1,i+2,1)~/[rwx]/)*2^(8-i));if(k){for(i=10;$i;i++)$9=$9" "$i;printf("%0o %s\n",k,$9)}}' > "$mods"
+ exit;;
+ M) while read -r mod path; do
+ sudo chmod -c "$mod" -- "$path"
+ done < "$mods"
+ exit;;
+ \?) exit 1;;
+ esac
+done
+shift $((OPTIND-1))
+$cmd "$@"
diff --git a/home/xyz/.local/bin/chmodef b/home/xyz/.local/bin/chmodef
new file mode 100755
index 00000000..be9b2934
--- /dev/null
+++ b/home/xyz/.local/bin/chmodef
@@ -0,0 +1,5 @@
+#!/bin/sh
+
+# https://wiki.archlinux.org/title/File_permissions_and_attributes#Numeric_method
+find "$@" -type d -execdir chmod 755 -- '{}' \+
+find "$@" -type f -execdir chmod 644 -- '{}' \+
diff --git a/home/xyz/.local/bin/convwall b/home/xyz/.local/bin/convwall
new file mode 100755
index 00000000..dff9c43b
--- /dev/null
+++ b/home/xyz/.local/bin/convwall
@@ -0,0 +1,34 @@
+#!/bin/sh
+
+# target image aspect ratio
+wratio=$SCR_WIDTH
+hratio=$SCR_HEIGHT
+# chop how much from center
+chopnum=99%
+
+# my benchmark shows -ping is much faster than default
+# https://github.com/ImageMagick/ImageMagick/issues/3183#issuecomment-800955241
+width=$(identify -ping -format '%w' "$1")
+height=$(identify -ping -format '%h' "$1")
+
+ratio=$((wratio*100/hratio))
+dim=$((width*100/height))
+
+if [ "$dim" -ne "$ratio" ]; then
+ if [ "$dim" -lt "$ratio" ]; then
+ chopgeom="${chopnum}x0"
+ width=$((height*wratio/hratio))
+ else
+ chopgeom="0x$chopnum"
+ height=$((width*hratio/wratio))
+ fi
+ # may throw error "sort: write failed: 'standard output': Broken pipe \n sort: write error"
+ # caused by head exit (or close stdin) before sort output complete, can ignore
+ # https://stackoverflow.com/questions/46202653/bash-error-in-sort-sort-write-failed-standard-output-broken-pipe
+ bgcolor=$(convert "$1" -gravity center -chop "$chopgeom" -define histogram:unique-colors=true -format %c histogram:info:- | sort -rn | head -n1 | awk \{print\ \$3\} | cut -c1-7)
+ # another approach is to use "$width" or "x$height" for geometry, current approach is more readable
+ convert "$1" -gravity center -background "$bgcolor" -extent "${width}x$height" "$2"
+else
+ echo 'same aspect ratio, no need to convert' >&2
+ exit 1
+fi
diff --git a/home/xyz/.local/bin/curlkg b/home/xyz/.local/bin/curlkg
new file mode 100755
index 00000000..9389e680
--- /dev/null
+++ b/home/xyz/.local/bin/curlkg
@@ -0,0 +1,42 @@
+#!/bin/sh
+
+# references:
+# https://blog.csdn.net/qq_41730930/article/details/79327757
+# https://blog.csdn.net/u011112876/article/details/89634505
+# https://github.com/pystardust/ytfzf
+
+homepage_url='https://node.kg.qq.com/cgi/fcgi-bin/kg_ugc_get_homepage'
+music_url='https://node.kg.qq.com/cgi/fcgi-bin/fcg_get_play_url'
+# num seems only 8 and 15 works
+num=15
+tmp_json_file="$(mktemp --suffix=.json)"
+
+while getopts u: opt; do
+ case $opt in
+ u) uid="$OPTARG";;
+ \?) exit 1;;
+ esac
+done
+# for lan lan, uid=649b9e82272a348b
+# for cheng ruan, uid=64949d822c25328c
+[ -z "$uid" ] && echo 'error: must provide share_uid
+ex: curlkg -u 649b9e82272a348b ./' >&2 && exit 1
+shift $((OPTIND-1))
+download_dir="${1:-"$PWD"}"
+[ -d "$download_dir" ] || mkdir -p "$download_dir"
+
+get_json ()
+{
+ curl -s -G --data-urlencode type=get_uinfo -d outCharset=utf-8 -d start="$1" -d num=$num -d share_uid="$uid" "$homepage_url" | sed 's/.*({\(.*\)}).*/{\1}/' >> "$tmp_json_file"
+}
+
+get_json 1
+ugc_total_count=$(jq '.data.ugc_total_count' "$tmp_json_file")
+# can also use while loop with i=$((i+1))
+# the calculation considers both ugc_total_count%num==0 and ugc_total_count%num>0
+for i in $(seq 2 $(((ugc_total_count+num-1)/num))); do
+ get_json "$i"
+done
+
+jq -r '.data.ugclist[]|"'"$music_url"'?shareid=\(.shareid)\n out=\(.title)_\(.time).m4a"' "$tmp_json_file" | aria2c -d "$download_dir" --auto-file-renaming=false --console-log-level=warn -i-
+rm "$tmp_json_file"
diff --git a/home/xyz/.local/bin/curlncm b/home/xyz/.local/bin/curlncm
new file mode 100755
index 00000000..582214ac
--- /dev/null
+++ b/home/xyz/.local/bin/curlncm
@@ -0,0 +1,86 @@
+#!/bin/sh
+# rewrite TianyiShi2001's python script which rewrite NeteaseCloudMusicApi node.js api
+
+# references:
+# https://github.com/ytdl-org/youtube-dl/issues/18051#issuecomment-859964832
+# https://github.com/Binaryify/NeteaseCloudMusicApi
+# info about encrytion and api:
+# https://github.com/metowolf/NeteaseCloudMusicApi/wiki
+# https://github.com/darknessomi/musicbox/wiki
+
+# lan lan, aid=48860966, rid=793052426, example id=1397315179,1817498734
+# cheng ruan, aid=46703185, rid=792968433
+
+# trial and error to get dj_max, don't know why, maybe because it is 2^31 and it is the size limit of whatever type of the variable
+dj_max=2147483647
+dl_urls_tmp="$(mktemp)"
+# printf 'e82ckenh8dichen8' | hexdump -ve '/1 "%02x"'
+key='653832636b656e683864696368656e38'
+url='/api/song/enhance/player/url'
+request_id=$(date +'%s%3N')_$(seq -w 1 1000 | shuf -n1)
+user_agent='Mozilla/5.0 (Linux; U; Android 9; zh-cn; Redmi Note 8 Build/PKQ1.190616.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/12.5.22'
+cookie="$(printf '"appver":"8.0.0","versioncode":"140","buildver":"1623455100","resolution":"1920x1080","__csrf":"","os":"pc","requestId":"%s"' "$request_id")"
+
+die ()
+{
+ echo "error: $*" >&2
+ exit 1
+}
+
+# let a i r mutually exclusive
+# artist, song, djradio id
+flag=0
+while getopts a:i:r: opt; do
+ case $opt in
+ a) [ "$flag" -eq 1 ] && die "options a,i,r are mutually exclusive"
+ aid="$OPTARG"
+ flag=1;;
+ i) [ "$flag" -eq 1 ] && die "options a,i,r are mutually exclusive"
+ ids="$OPTARG"
+ flag=1;;
+ r) [ "$flag" -eq 1 ] && die "options a,i,r are mutually exclusive"
+ rid="$OPTARG"
+ flag=1;;
+ \?) exit 1;;
+ esac
+done
+[ $flag -eq 0 ] && die "please specify at least one option"
+shift $((OPTIND-1))
+[ $# -gt 1 ] && die "directory name should be at the end"
+download_dir="${1:-"$PWD"}"
+[ -d "$download_dir" ] || mkdir -p "$download_dir"
+
+if [ -n "$ids" ]; then
+ # temporary solution, can improve by auto curl names
+ data="$(echo "$ids" | tr ',' '\n' | awk '{printf("%s\t%s\n",$0,"songname")}')"
+else
+ if [ -n "$rid" ]; then
+ data="$(curl -s -G --data-urlencode id="$rid" -d limit="$dj_max" 'https://music.163.com/djradio' | grep 'songlist\|tt f-thide' | sed -e 's/.*songlist-\(.*\)" class.*/\1/g' -e 's/.*title="\(.*\)".*/\1/g' | paste -sd '\t\n' | sort | tr '/' '_')"
+ # can only curl featured 50 songs for the artist, can improve
+ elif [ -n "$aid" ]; then
+ data="$(curl -s -G --data-urlencode id="$aid" 'https://music.163.com/artist' | grep '\[{.*}\]' | sed -e 's/.*>\[{/\[{/' -e 's/}\]<.*/}\]/' | jq -r '.[]|[.id,.name]|@tsv' | sort | tr '/' '_')"
+ fi
+ # awk code not print separator at beginning and end steal from:
+ # https://unix.stackexchange.com/a/581785/459013
+ # not sure awk one-liner or paste way which is better, need benchmark
+ ids="$(echo "$data" | awk -F'\t' '{printf "%s%s",sep,$1;sep=","}')"
+ #ids="$(echo "$data" | awk -F'\t' '{print $1}' | paste -sd ',')"
+fi
+
+# I don't fully understand following several lines of code
+# I rewrite TianyiShi2001's python script, he rewrites NeteaseCloudMusicApi
+text="$(printf '{"ids":"[%s]","br":999000,"header":{%s}}' "$ids" "$cookie")"
+message="nobody${url}use${text}md5forencrypt"
+digest="$(printf '%s' "$message" | openssl dgst -md5 -hex | awk '{print $2}')"
+params="$(printf '%s-36cd479b6b5-%s-36cd479b6b5-%s' "$url" "$text" "$digest")"
+encrypted_params="$(printf '%s' "$params" | openssl enc -aes-128-ecb -K "$key" | hexdump -ve '/1 "%02X"')"
+# curl default user agent header seems not working
+curl -s -A "$user_agent" -d params="$encrypted_params" 'https://interface3.music.163.com/eapi/song/enhance/player/url' | jq -r '.data|sort_by(.id)|.[].url' > "$dl_urls_tmp"
+[ "$(echo "$data" | wc -l)" -ne "$(wc -l < "$dl_urls_tmp")" ] && die "number of download uls doesn't match request"
+
+# can't download some music if live abroad, may need proxy or vpn
+# using user_agent, content-type header, cookie header, referer are not necessary? but feels faster
+# not sure about cookie header format for aria2c, this link shows that it's kinda messy, so I didn't use it
+# https://github.com/aria2/aria2/issues/545#issuecomment-650070869
+echo "$data" | awk -F'\t' '{printf(" out=%s_%s.mp3\n",$2,$1)}' | paste "$dl_urls_tmp" - -d '\n' | aria2c -U "$user_agent" --header='Content-Type: application/x-www-form-urlencoded' --referer='https://music.163.com' -d "$download_dir" --auto-file-renaming=false --console-log-level=warn -i-
+rm "$dl_urls_tmp"
diff --git a/home/xyz/.local/bin/curlqb b/home/xyz/.local/bin/curlqb
new file mode 100755
index 00000000..f98a41c8
--- /dev/null
+++ b/home/xyz/.local/bin/curlqb
@@ -0,0 +1,18 @@
+#!/bin/sh
+
+curl -s 'https://github.com/qbittorrent/search-plugins/wiki/Unofficial-search-plugins' | awk -F'"' '/Plugins for Private sites/{exit} /\.py/{url=$2;getline;getline;getline;if($0 !~ /❗|✖/)print url}' | xargs curl -s -Z -L --remote-name-all --create-dirs --output-dir "$1" --
+
+#curl -s 'https://github.com/qbittorrent/search-plugins/wiki/Unofficial-search-plugins' | awk -F'"' '{
+# if($0 ~ /Plugins for Private sites/)
+# exit
+# if($0 ~ /\.py/)
+# {
+# url=$2
+# getline
+# getline
+# getline
+# if($0 !~ /❗|✖/)
+# print url
+# }
+#}' | xargs curl -s -Z -L --remote-name-all --create-dirs --output-dir "$1" --
+
diff --git a/home/xyz/.local/bin/gita b/home/xyz/.local/bin/gita
new file mode 100755
index 00000000..a3d0dbc9
--- /dev/null
+++ b/home/xyz/.local/bin/gita
@@ -0,0 +1,18 @@
+#!/bin/sh
+# note message string must come after options
+
+cmd='git'
+
+while getopts clLsS f; do
+ case $f in
+ c|l|L|s|S) cmd="cfg -$f";;
+ \?) exit 1;;
+ esac
+done
+shift $((OPTIND-1))
+
+mes="${1:-refactor}"
+
+$cmd add -u
+$cmd commit -m "$mes"
+$cmd push
diff --git a/home/xyz/.local/bin/gitfork b/home/xyz/.local/bin/gitfork
new file mode 100755
index 00000000..cefc4f68
--- /dev/null
+++ b/home/xyz/.local/bin/gitfork
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+git clone "$1"
+cd "$(basename "$1" .git)" || exit
+git remote add upstream "$2"
+git branch fly
+git checkout fly
+git push --set-upstream origin fly
diff --git a/home/xyz/.local/bin/gitpu b/home/xyz/.local/bin/gitpu
new file mode 100755
index 00000000..fcc32be9
--- /dev/null
+++ b/home/xyz/.local/bin/gitpu
@@ -0,0 +1,19 @@
+#!/bin/sh
+
+if [ -z "$1" ]; then
+ git checkout master
+ git pull upstream master
+ git push
+ git checkout fly
+ git merge --no-edit master
+ git push
+else
+ for dir ; do
+ git -C "$dir" checkout master
+ git -C "$dir" pull upstream master
+ git -C "$dir" push
+ git -C "$dir" checkout fly
+ git -C "$dir" merge --no-edit master
+ git -C "$dir" push
+ done
+fi
diff --git a/home/xyz/.local/bin/mmi b/home/xyz/.local/bin/mmi
new file mode 100755
index 00000000..b3b5868f
--- /dev/null
+++ b/home/xyz/.local/bin/mmi
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+mi ()
+{
+ sudo make -B install
+}
+
+origin="$PWD"
+cmd='mi'
+
+while getopts q opt; do
+ case $opt in
+ q) cmd='qmake6;mi';;
+ \?) exit 1;;
+ esac
+done
+shift $((OPTIND-1))
+
+if [ -z "$1" ]; then
+ eval "$cmd"
+else
+ for dir ; do
+ cd "$dir" || exit
+ eval "$cmd"
+ cd "$origin" || exit
+ done
+fi
diff --git a/home/xyz/.local/bin/mpva b/home/xyz/.local/bin/mpva
new file mode 100755
index 00000000..7224cf46
--- /dev/null
+++ b/home/xyz/.local/bin/mpva
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+if [ $# -eq 0 ]; then
+ # fzf has --read0, maybe useful
+ find "$XDG_MUSIC_DIR" | fzf -m --print0 | xargs -0 mpv --af= --shuffle --loop-playlist=inf --video=no
+elif [ $# -eq 1 ]; then
+ # use --loop-file for single file, better performance maybe
+ mpv --af= --loop-file=inf --video=no "$1"
+else
+ mpv --af= --shuffle --loop-playlist=inf --video=no "$@"
+fi
diff --git a/home/xyz/.local/bin/mpvy b/home/xyz/.local/bin/mpvy
new file mode 100755
index 00000000..4471b668
--- /dev/null
+++ b/home/xyz/.local/bin/mpvy
@@ -0,0 +1,41 @@
+#!/bin/sh
+
+# references:
+# https://www.rockyourcode.com/til-how-to-watch-youtube-videos-with-mpv-and-keyboard-shortcuts/
+
+fps=30
+height=$SCR_HEIGHT
+url="$(xsel -ob)"
+flag=s
+
+# option f and h may do nothing if redownload? since same filename exist. yt-dlp won't download same file even without --auto-file-renameing=false. how improve? pass argument to aria2c?
+while getopts Aabd:f:h:su: opt; do
+ case $opt in
+ # s: streaming, a: aria2c then mpv, A: aria2c
+ A|a|s) flag=$opt;;
+ b) format='bestvideo+bestaudio/best';;
+ d) download_dir="$OPTARG";;
+ f) fps="$OPTARG";;
+ h) height="$OPTARG";;
+ u) url="$OPTARG";;
+ \?) exit 1;;
+ esac
+done
+if [ -z "$format" ]; then
+ vformat="[height<=?$height][fps<=?$fps][vcodec!^=?vp9][vcodec!^=?av01]"
+ # usually get .mp4 video + .webm audio on youtube, yt-dlp needs to merge them to .mkv
+ # it used to cause problem, but I forget
+ format="bestvideo$vformat+bestaudio/best$vformat"
+fi
+
+case $flag in
+ # here if use --write-sub, mpv doesn't recognize subtitles?
+ # --embed-subs is a little bit better, but still worse then direct streaming
+ A) yt-dlp -f "$format" --embed-subs -P "${download_dir:-"$XDG_DOWNLOAD_DIR/mpvy/"}" --sponsorblock-remove all "$url";;
+ a) yt-dlp -f "$format" --embed-subs -P "${download_dir:-/tmp/mpvy/}" --sponsorblock-remove all "$url" --exec 'mpv --fs --speed=2';;
+ s) mpv --ytdl-format="$format" --ytdl-raw-options='write-sub=' --fs --speed=2 "$url";;
+esac
+# not sure if this is the best practice, but it seems working ;)
+status=$?
+[ $status -ne 0 ] && notify-send 'mpvsel failed'
+exit $status
diff --git a/home/xyz/.local/bin/mvtr b/home/xyz/.local/bin/mvtr
new file mode 100755
index 00000000..850f8dba
--- /dev/null
+++ b/home/xyz/.local/bin/mvtr
@@ -0,0 +1,14 @@
+#!/bin/sh
+
+# can use ls pipe to sed pipe to bash, similar to eval? see comment at link:
+# link also show perl-rename approach
+# https://linuxconfig.org/rename-all-files-from-uppercase-to-lowercase-characters
+# if only change ' ' to '_' `rename` might be sufficient, for upper to lower case might need perl-rename if want concise
+
+# ./_filename will be renamed ./filename, not what I want, need improve
+# -exec can't replace -execdir here, can write a -exec version
+
+find "$@" -depth -execdir sh -c 'dest="$(echo "$1" | tr -d "\047" | sed -E -e "s/([[:lower:]])([[:upper:]])/\1_\2/g" | tr "[:upper:] " "[:lower:]_" | tr -s "[:punct:]" | sed -E -e "s#/-#/#g" -e "s/_([[:punct:]])/\1/g" -e "s/([[:punct:]])_/\1/g" | tr -s "[:punct:]")"; [ -e "$dest" ] || mv -v -- "$1" "$dest"' shell '{}' \;
+
+# for test
+#mkdir -p ~/test/A\ A/; rm -rf ~/test/A\ A/1t/; cp -r ~/test/0t/ ~/test/A\ A/1t/; time mvtr ~/test/A\ A/1t/; tree ~/test/A\ A/1t/
diff --git a/home/xyz/.local/bin/o b/home/xyz/.local/bin/o
new file mode 100755
index 00000000..21464974
--- /dev/null
+++ b/home/xyz/.local/bin/o
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+# useful links
+# https://stackoverflow.com/questions/3430330/best-way-to-make-a-shell-script-daemon
+# https://serverfault.com/questions/117152/do-background-processes-get-a-sighup-when-logging-off
+# https://wiki.archlinux.org/title/default_applications
+
+# I don't care about errors, I don't want to handle errors, just shut up please.
+# nohup seems not necessary if don't care about daemon SIGHUP requirement
+
+if [ $# -eq 1 ] && [ -e "$1" ] && ! [ -x "$1" ]; then
+ nohup xdg-open "$1" 0<&- >&- 2>&- &
+else
+ nohup "$@" 0<&- >&- 2>&- &
+fi
diff --git a/home/xyz/.local/bin/orgext b/home/xyz/.local/bin/orgext
new file mode 100755
index 00000000..f1654d2c
--- /dev/null
+++ b/home/xyz/.local/bin/orgext
@@ -0,0 +1,24 @@
+#!/bin/sh
+
+# references:
+# https://stackoverflow.com/questions/1842254/how-can-i-find-all-of-the-distinct-file-extensions-in-a-folder-hierarchy
+
+# not sure if find here need -depth, not sure if mv here need -n and -T
+
+outdir ()
+{
+ find . -type f -execdir mv -nt "$PWD" -- '{}' \+
+ find . -mindepth 1 -maxdepth 1 -type d -delete
+}
+
+indir ()
+{
+ find . -maxdepth 1 -type f | awk -F. '!a[$NF]++{print $NF}' | xargs mkdir --
+ find . -mindepth 1 -maxdepth 1 -type d -execdir basename -az -- '{}' \+ | xargs -0 -I _ find . -maxdepth 1 -type f -name '*._' -execdir mv -t '_' -- '{}' \+
+}
+
+case "$1" in
+ '-o') outdir;;
+ '-i') indir;;
+ *) outdir; indir;;
+esac
diff --git a/home/xyz/.local/bin/reco b/home/xyz/.local/bin/reco
new file mode 100755
index 00000000..d56e61c2
--- /dev/null
+++ b/home/xyz/.local/bin/reco
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+# useful urls:
+# https://github.com/LukeSmithxyz/voidrice/blob/master/.local/bin/dmenurecord
+# https://wiki.archlinux.org/title/FFmpeg#Screen_capture
+# https://trac.ffmpeg.org/wiki/Capture/Desktop
+
+infofile="/tmp/recoinfo"
+recodir="$XDG_VIDEOS_DIR/recordings/"
+mkdir -p "$recodir"
+
+if [ -e "$infofile" ]; then
+ read -r pid tmpfile < "$infofile"
+ kill "$pid"
+ notify-send 'finish recording, start converting'
+ ffmpeg -i "$tmpfile" "$recodir/$(time.uuid).mkv"
+ notify-send 'finish converting'
+ rm "$tmpfile" "$infofile"
+else
+ tmpfile="$(mktemp --suffix '.mkv')"
+ notify-send 'start recording'
+ # arch wiki way, no audio, less cpu use during capturing (fast?), large file size, need convert afterward
+ xrectsel '%w %h %x %y' | xargs sh -c 'ffmpeg -y -loglevel quiet -f x11grab -framerate 25 -s "$2"x"$3" -i "$DISPLAY+$4,$5" -c:v ffvhuff "$1" & echo $!' shell "$tmpfile" | xargs -I {} printf '%s\t%s' '{}' "$tmpfile" > "$infofile"
+ # another way to get subshell ffmpeg child pid
+ #xrectsel '%w %h %x %y' | xargs sh -c 'ffmpeg -y -f x11grab -framerate 25 -s "$2"x"$3" -i "$DISPLAY+$4,$5" -c:v ffvhuff "$1"' shell "$tmpfile" &
+ #printf '%s\t%s' "$(ps -o pid= --ppid $!)" "$tmpfile" > "$infofile"
+fi
diff --git a/home/xyz/.local/bin/sbar b/home/xyz/.local/bin/sbar
new file mode 100755
index 00000000..bd471f4a
--- /dev/null
+++ b/home/xyz/.local/bin/sbar
@@ -0,0 +1,90 @@
+#!/bin/sh
+# steal from pystardust, GPL3 license: https://github.com/pystardust/sbar
+# modified to fit my own need
+
+# INIT
+printf '%s' "$$" > "$XDG_CACHE_HOME/pidofbar"
+sec=0
+
+bool () {
+ read str
+ if [ "$str" = "on" ] || [ "$str" = "up" ] || [ "$str" = "Connected" ]; then
+ echo 1
+ else
+ echo 0
+ fi
+}
+
+# MODULES
+update_time () {
+ time="$(date '+%a %m/%d %H:%M') $(TZ=Asia/Shanghai date '+/%d %H:')"
+}
+
+update_cap () {
+ cap="$(if xset q | grep -q "Caps Lock: *on"; then echo A; else echo a; fi)"
+}
+
+update_net () {
+ net="$(bool < /sys/class/net/wlp6s0/operstate)"
+}
+
+update_vpn () {
+ vpn="$(mullvad status | awk '{print $3}' | bool)"
+}
+
+update_vol () {
+ vol="$(amixer get Master | awk -F'[][]' 'END{printf"%d %s",($4=="on")?1:0,$2}')"
+}
+
+update_mic () {
+ mic="$(amixer get Capture | awk -F'[][]' 'END{print $4}' | bool)"
+}
+
+update_bat () {
+ bat="$(cat /sys/class/power_supply/BAT1/capacity)%"
+}
+
+# For calcurse users, refer https://github.com/pystardust/automeet
+#update_event () {
+# event="$(calcurse -n | sed 1d | \
+# sed -E "s_^ *\[(.*):(.*)\] ([^\t]*)\t?.*_[\1h \2m->\3]_")"
+# [ "[]" = "$event" ] && event=""
+#}
+
+# modules that don't update on their own need to be run at the start for getting their initial value
+update_vol
+update_mic
+update_cap
+
+display () {
+ xsetroot -name "$(echo "$time | N $net V $vpn | M $vol C $mic | $cap | $bat")"
+}
+
+# SIGNALLING
+# trap "<function>;display" "RTMIN+n"
+trap "update_mic;display" "RTMIN"
+trap "update_vol;display" "RTMIN+1"
+# xev can't read my toggle internet keyboard key, don't know what key to use in sxhkd to send signal
+#trap "update_net;display" "RTMIN+2"
+trap "update_cap;display" "RTMIN+3"
+trap "update_vpn;display" "RTMIN+4"
+# to update it from external commands
+## kill -m "$(cat "$XDG_CACHE_HOME/pidofbar")"
+# where m = 34 + n
+
+while true; do
+ # next line of code seems make hotkeys that send kill signals more responsive? not fully understood
+ sleep 1 & wait && {
+ # to update item ever n seconds with a offset of m
+ ## [ $((sec % n)) -eq m ] && udpate_item
+ [ $((sec % 5 )) -eq 0 ] && update_time # update time every 5 seconds
+ [ $((sec % 5 )) -eq 0 ] && update_net
+ [ $((sec % 5 )) -eq 0 ] && update_vpn
+ [ $((sec % 60)) -eq 0 ] && update_bat
+ #[ $((sec % 300)) -eq 1 ] && update_event
+
+ # how often the display updates ( 5 seconds )
+ [ $((sec % 5 )) -eq 0 ] && display
+ sec=$((sec + 1))
+ }
+done
diff --git a/home/xyz/.local/bin/shufwall b/home/xyz/.local/bin/shufwall
new file mode 100755
index 00000000..5b249e12
--- /dev/null
+++ b/home/xyz/.local/bin/shufwall
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+if [ -z "$1" ]; then
+ file=$(find -L "$XDG_PICTURES_DIR/wallpapers" -type f | shuf -n 1)
+else
+ file=$(find -L "$@" -maxdepth 1 -type f | shuf -n 1)
+fi
+
+display -resize "${SCR_WIDTH}x$SCR_HEIGHT" -backdrop -window root "$file"
diff --git a/home/xyz/.local/bin/time.uuid b/home/xyz/.local/bin/time.uuid
new file mode 100755
index 00000000..11cc67ad
--- /dev/null
+++ b/home/xyz/.local/bin/time.uuid
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+# echo current nanosecond since epoch and alpha-numerically ordered UUID
+# https://stackoverflow.com/questions/28681650/generate-alpha-numerically-ordered-uuids-over-time?noredirect=1&lq=1
+# https://askubuntu.com/questions/342842/what-does-this-command-mean-awk-f-print-4
+echo "$(date '+%s.%N').$(uuidgen -t | awk -F- '{OFS="-"; print $3,$2,$1,$4,$5}')"
diff --git a/home/xyz/.local/bin/topa b/home/xyz/.local/bin/topa
new file mode 100755
index 00000000..e921bc31
--- /dev/null
+++ b/home/xyz/.local/bin/topa
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+o alacritty -e htop
+o alacritty -e radeontop -c
+o alacritty -e sudo iotop
+o alacritty -e sudo nethogs
diff --git a/home/xyz/.local/bin/upd b/home/xyz/.local/bin/upd
new file mode 100755
index 00000000..65452b37
--- /dev/null
+++ b/home/xyz/.local/bin/upd
@@ -0,0 +1,120 @@
+#!/bin/sh
+
+all ()
+{
+ fast
+ usb
+ qb
+ ncm
+ kg
+ refl
+ gall
+}
+
+# not in all
+clean ()
+{
+ nsxiv -c
+ # my ways
+ # -exec can't replace -execdir here
+ find "$XDG_CACHE_HOME/nsxiv/" -depth -type d -empty -execdir rmdir -- '{}' \+
+ # -exec can replace -execdir here
+ #find "$XDG_CACHE_HOME/nsxiv/" -depth -type d -execdir rmdir --ignore-fail-on-non-empty -- '{}' \+
+ # nsxiv man page way
+ #find "$XDG_CACHE_HOME/nsxiv/" -depth -type d -empty ! -name '.' -exec rmdir -- '{}' \;
+ rm "$HOME/.mozilla/firefox/xxxxxxxx.fly/prefs.js.backup."*
+}
+
+fast ()
+{
+ pac
+ misc
+}
+
+gall ()
+{
+ gallery-dl --download-archive "$XDG_DOCUMENTS_DIR/database/gallery-dl.sqlite3" -d "$XDG_PICTURES_DIR/anime/gallery-dl/" -i "$XDG_CONFIG_HOME/myconf/gallery_urls"
+}
+
+userjs ()
+{
+ kill $(pidof "$BROWSER")
+ "$HOME/.mozilla/firefox/xxxxxxxx.fly/prefsCleaner.sh" -s
+ "$HOME/.mozilla/firefox/xxxxxxxx.fly/updater.sh" -us
+}
+
+g ()
+{
+ curlkg -u649b9e82272a348b -- "$XDG_MUSIC_DIR/not_pure/lan_lan/kg/"
+ curlkg -u64949d822c25328c -- "$XDG_MUSIC_DIR/not_pure/cheng_ruan/kg/"
+}
+
+misc ()
+{
+ cfg -c submodule foreach git pull
+ nvim +PlugUpgrade +PlugClean! +PlugUpdate +qa
+ tldr --update
+ sudo hardcode-fixer
+ userjs
+}
+
+ncm ()
+{
+ curlncm -a48860966 -- "$XDG_MUSIC_DIR/not_pure/lan_lan/ncm/artist/"
+ curlncm -a46703185 -- "$XDG_MUSIC_DIR/not_pure/cheng_ruan/ncm/artist/"
+ curlncm -r793052426 -- "$XDG_MUSIC_DIR/not_pure/lan_lan/ncm/djradio/"
+ curlncm -r792968433 -- "$XDG_MUSIC_DIR/not_pure/cheng_ruan/ncm/djradio/"
+}
+
+pac ()
+{
+ sudo pacman --noconfirm -Syu
+ paru --noconfirm -aSyu
+ # part steal from aur comment
+ # sometimes "ERROR: Failure while downloading": https://github.com/neovim/neovim/issues/15709
+ rm -rf ~/.cache/paru/clone/neovim-nightly-bin/ && yes 1 | PARU_PAGER=cat paru --rebuild --redownload neovim-nightly-bin
+ sudo pacman -Fy
+}
+
+qb ()
+{
+ rm -r -- "$HOME/programs/qbittorrent_search_plugins/"
+ curlqb "$HOME/programs/qbittorrent_search_plugins/"
+}
+
+refl ()
+{
+ sudo reflector --save /etc/pacman.d/mirrorlist --latest 200 --sort rate
+}
+
+usb ()
+{
+ cfg -c push usb
+ cfg -l push usb
+ cfg -s push
+ git --git-dir="$XDG_DOCUMENTS_DIR/notes/.git" --work-tree="$XDG_DOCUMENTS_DIR/notes/" push usb
+}
+
+
+if [ $# -eq 0 ]; then
+ fast
+else
+ while getopts acfgjkmnpqru opt; do
+ case $opt in
+ a)all;;
+ # not in all
+ c)clean;;
+ f)fast;;
+ g)gall;;
+ j)userjs;;
+ k)kg;;
+ m)misc;;
+ n)ncm;;
+ p)pac;;
+ q)qb;;
+ r)refl;;
+ u)usb;;
+ \?)exit 1;;
+ esac
+ done
+fi
diff --git a/home/xyz/.profile b/home/xyz/.profile
new file mode 100644
index 00000000..fc2f2066
--- /dev/null
+++ b/home/xyz/.profile
@@ -0,0 +1,66 @@
+#!/bin/sh
+
+# here `. ~/.bashrc` same as `source ~/.bashrc`, see `source filename` in `man bash`, and `. file` in `man dash`
+# `. file` is POSIX compliant, while `source file` is not
+# https://github.com/koalaman/shellcheck/wiki/SC3046
+#[[ -f ~/.bashrc ]] && . ~/.bashrc
+[ -f "$HOME/.bashrc" ] && . "$HOME/.bashrc"
+
+export XDG_CONFIG_HOME="$HOME/.config/"
+export XDG_CACHE_HOME="$HOME/.cache/"
+export XDG_DATA_HOME="$HOME/.local/share/"
+
+. "$XDG_CONFIG_HOME/user-dirs.dirs"
+export XDG_DESKTOP_DIR="$XDG_DESKTOP_DIR"
+export XDG_DOWNLOAD_DIR="$XDG_DOWNLOAD_DIR"
+export XDG_TEMPLATES_DIR="$XDG_TEMPLATES_DIR"
+export XDG_PUBLICSHARE_DIR="$XDG_PUBLICSHARE_DIR"
+export XDG_DOCUMENTS_DIR="$XDG_DOCUMENTS_DIR"
+export XDG_MUSIC_DIR="$XDG_MUSIC_DIR"
+export XDG_PICTURES_DIR="$XDG_PICTURES_DIR"
+export XDG_VIDEOS_DIR="$XDG_VIDEOS_DIR"
+
+export PATH="$(find "$HOME/.local/bin" -type d -printf %p:)$PATH"
+export HISTSIZE=7000
+export HISTFILESIZE=7000
+
+export MANPAGER='nvim +Man!'
+export EDITOR=nvim
+export BROWSER=firefox
+
+export SSH_AUTH_SOCK="$XDG_RUNTIME_DIR/ssh-agent.socket"
+export INPUTRC="$XDG_CONFIG_HOME/readline/inputrc"
+#export QT_QPA_PLATFORMTHEME=qt5ct
+export QT_QPA_PLATFORMTHEME=gtk2
+#export QT_STYLE_OVERRIDE=kvantum
+export SDCV_PAGER='less --quit-if-one-screen -RX'
+export SXHKD_SHELL=sh
+export _ZO_ECHO=1
+
+# use sudo find for some files or dirs that has no permission ex: ~/.cache/paru/clone/
+#export FZF_DEFAULT_COMMAND="fd --no-ignore --hidden --exclude .git"
+#export FZF_CTRL_T_COMMAND="fd --absolute-path --no-ignore --hidden --exclude .git"
+#export FZF_ALT_C_COMMAND="fd --no-ignore --hidden --type d --exclude .git"
+export FZF_DEFAULT_COMMAND="sudo find . -mindepth 1 -path '*/\.git' -prune -o -print"
+# https://askubuntu.com/questions/444551/get-absolute-path-of-files-using-find-command
+# following two lines if use "" on the outermost, will not perfom expected, not sure why
+export FZF_CTRL_T_COMMAND='sudo find "$PWD" -mindepth 1 -path "*/\.git" -prune -o -print'
+#export FZF_CTRL_T_COMMAND='sudo find "$(pwd)" -path "*/\.git" -prune -o -print'
+# ~+ is bashism
+#export FZF_CTRL_T_COMMAND="sudo find ~+ -path '*/\.git' -prune -o -print"
+export FZF_ALT_C_COMMAND="sudo find . -mindepth 1 -path '*/\.git' -prune -o -type d -print"
+
+# for clipmenu
+# set clipmenud to store clipboard only, don't store selection (primary)
+#export CM_SELECTIONS="clipboard"
+# X11, copy / close program / paste to another program, if 0 will paste nothing
+#export CM_OWN_CLIPBOARD=1
+#export CM_MAX_CLIPS=8
+
+export SCR_WIDTH=1600
+export SCR_HEIGHT=900
+
+# startx when login, should be put after environmental variables for .xinitrc to use
+if [ -z "$DISPLAY" ] && [ "$XDG_VTNR" -eq 1 ]; then
+ exec startx
+fi
diff --git a/home/xyz/.xinitrc b/home/xyz/.xinitrc
new file mode 100644
index 00000000..65d91797
--- /dev/null
+++ b/home/xyz/.xinitrc
@@ -0,0 +1,52 @@
+#!/bin/sh
+
+userresources="$HOME/.Xresources"
+usermodmap="$HOME/.Xmodmap"
+sysresources=/etc/X11/xinit/.Xresources
+sysmodmap=/etc/X11/xinit/.Xmodmap
+
+# merge in defaults and keymaps
+
+if [ -f $sysresources ]; then
+ xrdb -merge $sysresources
+fi
+
+if [ -f $sysmodmap ]; then
+ xmodmap $sysmodmap
+fi
+
+if [ -f "$userresources" ]; then
+ xrdb -merge "$userresources"
+fi
+
+if [ -f "$usermodmap" ]; then
+ xmodmap "$usermodmap"
+fi
+
+# start some nice programs
+
+if [ -d /etc/X11/xinit/xinitrc.d ] ; then
+ for f in /etc/X11/xinit/xinitrc.d/?*.sh ; do
+ [ -x "$f" ] && . "$f"
+ done
+ unset f
+fi
+
+export GTK_IM_MODULE=fcitx
+export QT_IM_MODULE=fcitx
+export XMODIFIERS='@im=fcitx'
+
+#shufwall &
+display -window root "$XDG_PICTURES_DIR/wallpapers/wallpaper" &
+#clipmenud &
+dunst &
+fcitx5 -d &
+redshift &
+sbar &
+sxhkd &
+udiskie &
+# default fastest windows 10 keyboard repeat delay and rate
+# without editing registry, using filter key, or other third party program
+# see http://stereopsis.com/keyrepeat/
+xset r rate 250 30 &
+exec dwm